# -*- coding: utf-8 -*-

#  Copyright © 2016  B. Clausius <barcc@gmx.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.


from .common import ffi, print_cdata

ffi.cdef("""
//from galaxies.c
typedef struct space {
    int x, y;           /* its position */
    int type;
    unsigned int flags;
    int dotx, doty;     /* if flags & F_TILE_ASSOC */
    int nassoc;         /* if flags & F_DOT */
} space;

struct game_state {
    int w, h;           /* size from params */
    int sx, sy;         /* allocated size, (2x-1)*(2y-1) */
    space *grid;
    int completed, used_solve;
    int ndots;
    space **dots;

    midend *me;         /* to call supersede_game_desc */
    int cdiff;          /* difficulty of current puzzle (for status bar),
                           or -1 if stale. */
};

struct game_ui {
    int dragging;
    int dx, dy;         /* pixel coords of drag pos. */
    int dotx, doty;     /* grid coords of dot we're dragging from. */
    int srcx, srcy;     /* grid coords of drag start */
    int cur_x, cur_y, cur_visible;
};
""")

def tool(ui, state):
    ui = ui[0]
    state = state[0]
    #print_cdata(ui)
    #print_cdata(state)
    
    res1 = ['E{},{}'.format(x,y)
                for x in range(1, state.sx-1, 2)
                for y in range(2, state.sy-1, 2)]
    res2 = ['E{},{}'.format(x,y)
                for x in range(2, state.sx-1, 2)
                for y in range(1, state.sy-1, 2)]
    return ';'.join(res1+res2)
    
    

