# -*- coding: utf-8 -*-

#  Copyright © 2015-2016  B. Clausius <barcc@gmx.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

from .common import ffi, print_cdata

ffi.cdef("""
//from pearl.c
struct shared_state {
    int w, h, sz;
    unsigned char *clues;         /* size w*h */
    int refcnt;
};

struct game_state {
    struct shared_state *shared;
    unsigned char *lines;        /* size w*h: lines placed */
    char *errors;       /* size w*h: errors detected */
    char *marks;        /* size w*h: 'no line here' marks placed. */
    int completed, used_solve;
    int loop_length;    /* filled in by check_completion when complete. */
};

struct game_ui {
    int *dragcoords;       /* list of (y*w+x) coords in drag so far */
    int ndragcoords;       /* number of entries in dragcoords.
                            * 0 = click but no drag yet. -1 = no drag at all */
    int clickx, clicky;    /* pixel position of initial click */

    int curx, cury;        /* grid position of keyboard cursor */
    int cursor_active;     /* TRUE iff cursor is shown */
};

""")

def tool(ui, state):
    #print_cdata(ui)
    #print_cdata(state)
    shared = state.shared[0]
    #print_cdata(shared)
    res1 = ['F1,{0},{1};F4,{2},{1}'.format(x,y,x+1)
                for x in range(shared.w-1)
                for y in range(shared.h)]
    res2 = ['F8,{0},{1};F2,{0},{2}'.format(x,y,y+1)
                for x in range(shared.w)
                for y in range(shared.h-1)]
    return ';'.join(res1+res2)
    
    

